import matplotlib.pyplot as plt
import pandas as pd
from upsetplot import from_contents
import matplotlib as mpt
from upsetplot import plot
import argparse
import os

parser= argparse.ArgumentParser("UpSet Plot for bed file intersections")
parser.add_argument('-i', type=str, nargs='*', help="Path to bed files")
args = parser.parse_args()

files = args.i
contents = {}
liste = []
for file_name in files:
    filebasename = os.path.splitext(os.path.basename(file_name))[0]
    liste.append(filebasename)
    file_read = pd.read_csv(file_name, sep='\t', names=['Chromosome', 'start', 'end'])
    file_set = set(zip(file_read['Chromosome'], file_read['start'], file_read['end']))
    contents[filebasename] = file_set
print("#----- You are working on these files to construct UpSetPlot : -----#")
for name in liste:
    print(name)
# Ajoutez tous les ensembles de données à un dictionnaire et tracez le graphique UpSet
upset_data = from_contents(contents)
plot(upset_data, subset_size="count", show_counts=True, show_percentages=True, facecolor="darkblue", shading_color="lightgray")
plt.show()
